-- Alternatively tag ages as "adult", "elderly", "workforce" and "minor".

local ageGroups = {
	"child",
	"teen",
	"young adult",
	"adult",
	"mature adult",
	"elder",
	"old",
	"venerable"
}

function generateRandomAge(race)
  return randomFrom(eitherOr(race == "undead", olderThan("teen"), ageGroups))
--[[
	if includes == "any" then
		return randomFrom(ageGroups)
  elseif includes == "NoMinor" then
		return randomFrom(withoutV(ageGroups, "child", "teen"))
	elseif includes == "Noelder" then
		return randomFrom(withoutV(ageGroups, "elder", "old", "venerable"))
	else
		error ("Includes input: \"" .. includes .. "\" not handled.")
	end
  ]]
end

function olderThan(age)
  return skipWhile(function(x) return x == age end, ageGroups)
end

function youngerThan(age)
  return takeWhile(function(x) return x == age end, ageGroups)
end

function agesBetween(min, max)
  local output = skipWhile(function(x) return x == min end, youngerThan(max))
  table.insert(output, max)
  return output
end

-- End of File