-- Adding "any" and another will always return true.

local alignments = { }
alignments["lawful good"    ] = { moral = {    "good", "any" } }
alignments["lawful neutral" ] = { moral = { "neutral", "any" } }
alignments["lawful evil"    ] = { moral = {    "evil", "any" } }
alignments["neutral good"   ] = { moral = {    "good", "any" } }
alignments["true neutral"   ] = { moral = { "neutral", "any" } }
alignments["neutral evil"   ] = { moral = {    "evil", "any" } }
alignments["chaotic good"   ] = { moral = {    "good", "any" } }
alignments["chaotic neutral"] = { moral = { "neutral", "any" } }
alignments["chaotic evil"   ] = { moral = {    "evil", "any" } }

function generateRandomAlignment(characterTemplate, moral)
	return randomFrom(
		filterKeysByValue(
			function(val) return
				contains(moral or "any",	val.moral) --[[or contains(params.moral, val.moral)]]
			end,
			alignments
		)
	)
end

function alignmentsWithMoral(moral)
  return filterKeysByValue(
    function(val) return
      contains(moral, val.moral)
    end,
    alignments
  )
end

function allAlignmentsExcept(...)
  local args = {...}
  return without(keys(alignments), args)
end

-- Legacy code >.>

local alignment_moral   = { 
	"good", 
	"neutral", 
	"evil"
}

local alignment_ethical = { 
	"chaotic", 
	"neutral", 
	"lawful" 
}

function generateRandomAlignment2(moral, ethical, faith)
	output = ""
	
	if ethical == "any" then
		output = output .. randomFrom(alignment_ethical)
	elseif ethical == "nochaotic" then
		output = output .. randomFrom(withoutV(alignment_ethical, "chaotic"))
	elseif ethical == "nolawful" then
		output = output .. randomFrom(withoutV(alignment_ethical, "lawful"))
	else
		error("Ethical Input \"" .. ethical .. "\" not handled!")
	end
	
	output = output .. " "
	
	if moral == "any" then
		output = output .. randomFrom(alignment_moral)
	elseif moral == "noevil" then
		output = output .. randomFrom(withoutV(alignment_moral, "evil"))
	elseif moral == "nogood" then
		output = output .. randomFrom(withoutV(alignment_moral, "good"))
	else
		error("Moral Input \"" .. moral .. "\" not handled!")
	end
	
	if output == "neutral neutral" then
		return "true neutral"
	end
	
	return output
end

-- End of File