-- Alternatively, "tag" races under factions like the other options are. races["troll"] = { factions = { "horde", "enemy" } }
-- Second thought, make faction a second class feature, decoupled from the interface, but part of the main traits.

local races = { }
races["blood elf"] = { raceTypes = {     "horde",
                                     "civilized",
                                         "elven",
                                         "magic" } }
races["death knight"] = { raceTypes = { "neutral" } }
races[  "draenei"] = { raceTypes = {  "alliance",
                                        "tribal",
} }
races[    "dwarf"] = { raceTypes = {  "alliance",
                                     "civilized",
} }
races[    "gnome"] = { raceTypes = {  "alliance",
                                     "civilized",
                                         "magic"
} }
races[   "goblin"] = { raceTypes = {   "neutral",
} }
races[ "half elf"] = { raceTypes = {   "neutral",
                                      "alliance",
                                         "horde",
                                     "civilized",
                                         "elven",
                                     "halfbreed",
                                         "magic"
} }
races[ "half orc"] = { raceTypes = {   "neutral",
                                      "alliance",
                                         "horde",
                                     "civilized",
                                     "halfbreed",
                                        "tribal",
} }
races[ "high elf"] = { raceTypes = {  "alliance",
                                     "civilized",
                                         "elven",
                                         "magic"
} }
races[    "human"] = { raceTypes = {  "alliance",
                                     "civilized",
                                         "magic"
} }
races["night elf"] = { raceTypes = {  "alliance",
                                     "civilized",
                                         "elven",
} }
races[      "orc"] = { raceTypes = {  "alliance",
                                        "tribal",
} }
races[ "pandaren"] = { raceTypes = {   "neutral",
                                      "alliance",
                                         "horde",
} }
races[   "tauren"] = { raceTypes = {     "horde",
                                        "tribal",
} }
races[    "troll"] = { raceTypes = {     "horde",
                                        "tribal",
} }
races[   "undead"] = { raceTypes = {     "horde",
                                     "civilized",
} }
races[   "worgen"] = { raceTypes = {  "alliance",
                                     "civilized",
} }

local horde_races = {
	"orc",
	"troll",
	"undead",
	"blood elf",
	"tauren",
	"goblin",
	"pandaren"
}

local alliance_races = {
	"human",
	"dwarf",
	"gnome",
	"night elf",
	"draenei",
	"worgen",
	"pandaren"
}

local non_player_races = {
	"half elf",
	"half orc",
	"high elf"
}

--[[
local function generateRace(characterTemplate)
	if includes == "OnlyHorde" then
		return horde_races
	elseif includes == "OnlyAlly" then
		return alliance_races
	elseif includes == "OnlyNonPlayer" then
		return non_player_races
	elseif includes == "NoHorde" then
		return mergeTables(alliance_races, non_player_races)
	elseif includes == "NoAlly" then
		return mergeTables(horde_races, non_player_races)
	elseif includes == "Playable" then
		return mergeTables(alliance_races, horde_races)
	elseif includes == "any" then
		return mergeTables(alliance_races, horde_races, non_player_races)
	else
		error("Includes Input: \"" .. includes .. "\" not handled.")
	end
end
]]

function generateRandomRace()
  return randomFrom(keys(races)) or log("Error: No options found for Race!")
end

function allRacesExcept(...)
  return without(keys(races), {...})
end

-- racesByType :: RaceType -> { Race }
function racesByType(raceType)
  return filterKeysByValue(
    function(x) return
      contains(raceType, x.raceTypes)
    end,
    eitherOr(raceType == "any", { }, races)
  )
end

-- End of File.