characterTemplate = { }

function npcGenerator_OnLoad(self)
  characterTemplate.Motivation = { }
  characterTemplate.getName       = function()  return getInternalName(string.lower(box_Name:GetText()))       end
  characterTemplate.getRace       = function()  return getInternalName(string.lower(box_Race:GetText()))       end
  characterTemplate.getTribe	  	= function()  return getInternalName(string.lower(box_Tribe:GetText()))	   	 end
  characterTemplate.getGender     = function()  return getInternalName(string.lower(box_Gender:GetText()))     end
  characterTemplate.getClass      = function()  return getInternalName(string.lower(box_Class:GetText()))      end
  characterTemplate.getAlignment  = function()  return getInternalName(string.lower(box_Alignment:GetText()))  end
  characterTemplate.getAge        = function()  return getInternalName(string.lower(box_Age:GetText()))        end
  characterTemplate.getFaith      = function()  return getInternalName(string.lower(box_Faith:GetText()))      end
  characterTemplate.getFeature    = function()  return getInternalName(string.lower(box_Feature:GetText()))    end
  characterTemplate.getMotivation = function(i) 
    if i == 1 then
      return string.lower(box_Motivation1:GetText())
    elseif i == 2 then
      return string.lower(box_Motivation2:GetText())
    elseif i == 3 then
      return string.lower(box_Motivation3:GetText())
    end
  end
  
  characterTemplate.setName       = function(x)  box_Name:SetText(      ucWords(x)) end
  characterTemplate.setRace       = function(x)  box_Race:SetText(      ucWords(x)) end
  characterTemplate.setTribe	  	= 
		function(x)
			-- Change interface to reflect context, like:
			-- undead uses "subrace";
			-- tauren uses  "tribe";
			local tribeContext = ucFirst(getTribeContext(characterTemplate.getRace()))
			frm_Main.charTribe:SetText(tribeContext)
			-- If a race has no context for this trait, remove the visibility.
			if tribeContext == "" then
				box_Tribe:SetText("")
				--box_Tribe:Hide()
				--frm_Main.rollTribe:Hide()
			else
				--box_Tribe:Show()
				box_Tribe:SetText(ucWords(x))
				--frm_Main.rollTribe:Show()
			end
		end
  characterTemplate.setGender     = function(x)  box_Gender:SetText(    ucFirst(x)) end
  characterTemplate.setClass      = function(x)  box_Class:SetText(     ucWords(x)) end
  characterTemplate.setAlignment  = function(x)  box_Alignment:SetText( ucWords(x)) end
  characterTemplate.setAge        = function(x)  box_Age:SetText(       ucWords(x)) end
  characterTemplate.setFaith      = function(x)  box_Faith:SetText(     ucWords(x)) end
  characterTemplate.setFeature    = function(x)  box_Feature:SetText(   ucFirst(x)) end
  characterTemplate.setMotivation = function(i, x) 
    if i == 1 then
      return box_Motivation1:SetText(ucFirst(x))
    elseif i == 2 then
      return box_Motivation2:SetText(ucFirst(x))
    elseif i == 3 then
      if box_Motivation2:GetText() == "" and x ~= "" then
        return box_Motivation2:SetText(ucFirst(x))
      else
        return box_Motivation3:SetText(ucFirst(x))
      end
    end
  end  
  
  
  --testMotivationLength()
end

function testMotivationLength()
  local oneFound = false
  local fontString = box_Motivation1:CreateFontString("testFontString")
  local dl, dr = box_Motivation1:GetTextInsets()
  local width = box_Motivation1:GetWidth() - (dl + dr)
  map(
    function(x)
      local current = generateRandomMotivation(characterTemplate)
      fontString:SetFont(box_Motivation1:GetFont())
      fontString:SetText(current)
      if(fontString:GetStringWidth() > width) then
        if(not oneFound) then
          print "The following motivations are too long for the input box."
          oneFound = true
        end
        print(current)
      end
    end,
    replicate(10000, "")
  )
  
    print "Ended testing motivation lengths"
end



-- End of File.